/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qmessagebox.h>
#include "hangul/hangul.h"

#include "WRfid.h"
#include "WCode.h"
#include "WMachine.h"

#include "WClerk.h"
#include "WCustomer.h"

#include "WInfoCheck.h"
#include "WStatics.h"

#include "WCard.h"

#define MENU_DEFAULT 0
#define MENU_SYSTEM 1
#define MENU_PERSON 2
#define MENU_REALTIME 3
#define MENU_CARD 4

#define SUBMENU_DEFAULT 0
#define SUBMENU_RFID 1
#define SUBMENU_CODE 2
#define SUBMENU_MACHINE 3

#define SUBMENU_CLERK 4
#define SUBMENU_CUSTOMER 5

#define SUBMENU_INFOCHECK 6
#define SUBMENU_STATICS 7

#define SUBMENU_CARD 8

void CWMain::init()
{
	//
	btn1->toggle();
	subMenus->raiseWidget( MENU_CARD );
	
	//
	CWRfid* wRfid = new CWRfid( workStack );
	CWCode* wCode = new CWCode( workStack );
	CWMachine* wMachine = new CWMachine( workStack );
	
	CWClerk* wClerk = new CWClerk( workStack ) ;
	CWCustomer* wCustomer = new CWCustomer( workStack );
	
	CWInfoCheck* wInfoCheck = new CWInfoCheck( workStack );
	CWStatics* wStatics = new CWStatics( workStack );
	
	CWCard* wCard = new CWCard( workStack );
					
	
	workStack->addWidget( wRfid, SUBMENU_RFID );
	workStack->addWidget( wCode, SUBMENU_CODE );
	workStack->addWidget( wMachine, SUBMENU_MACHINE );
	
	workStack->addWidget( wClerk, SUBMENU_CLERK );
	workStack->addWidget( wCustomer, SUBMENU_CUSTOMER );
	
	workStack->addWidget( wInfoCheck, SUBMENU_INFOCHECK );
	workStack->addWidget( wStatics, SUBMENU_STATICS );
	
	workStack->addWidget( wCard, SUBMENU_CARD );
}

// 서브 메뉴 - 시스템 관리
void CWMain::slotBtnRfidClicked()
{
	workStack->raiseWidget( SUBMENU_RFID );	
}
void CWMain::slotBtnCodeClicked()
{
	workStack->raiseWidget( SUBMENU_CODE );	
}
void CWMain::slotBtnMachineClicked()
{
	workStack->raiseWidget( SUBMENU_MACHINE );	
}


// 서브 메뉴 - 사용자 관리
void CWMain::slotBtnClerkClicked()
{
	workStack->raiseWidget( SUBMENU_CLERK );	
}
void CWMain::slotBtnCustomerClicked()
{
	workStack->raiseWidget( SUBMENU_CUSTOMER );	
}

// 서브 메뉴 - 실시간 정보현황
void CWMain::slotBtnInfoCheckClicked()
{
	workStack->raiseWidget( SUBMENU_INFOCHECK );	
}
void CWMain::slotBtnStaticsClicked()
{
	workStack->raiseWidget( SUBMENU_STATICS );	
}

// 서브 메뉴 - 카드관리
void CWMain::slotBtnCardClicked()
{
	workStack->raiseWidget( SUBMENU_CARD );	
}


// 메인 메뉴
void CWMain::slotBtn1Clicked()
{
	subMenus->raiseWidget( MENU_SYSTEM );
}

void CWMain::slotBtn2Clicked()
{
	subMenus->raiseWidget( MENU_PERSON );
}

void CWMain::slotBtn3Clicked()
{
	subMenus->raiseWidget( MENU_REALTIME );
}

void CWMain::slotBtn4Clicked()
{
	subMenus->raiseWidget( MENU_CARD );
}

void CWMain::slotBtnHelpClicked()
{
}

void CWMain::closeEvent( QCloseEvent* e )
{
	int flagQuit =  QMessageBox::question(
					this,
					kor("프로그램 종료 확인"),
					kor("정말로 프로그램을 종료하시겠습니까?"),
					tr("&Yes"),	tr("&No"), 0,
					1, 1
				);
	if ( flagQuit==0 )
	{	// yes
		e->accept();
		emit closed();
	}
	else
	{	// no
		e->ignore();
	}
}
