/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include "hangul.h"
#include "stdlib.h"

#define LOSE -1
#define DRAW 0
#define WIN 1

#define SCISSORS 0
#define ROCK 1
#define PAPER 2

#define MIN_NUM 0
#define MAX_NUM 2
#define RAND_NUM(min, max) (  ( rand() % (max-min+1) ) + min  )
#define RAND() RAND_NUM(MIN_NUM, MAX_NUM)


void CWGame::init()
{
	//-------------------
	imgMark.load("./images/qqq.png");
	pixMark.convertFromImage( imgMark );
	labelScrCom->setPixmap( pixMark );
	labelScrUsr->setPixmap( pixMark );
	
	//-------------------
	pixBtn[0].load("./images/scissors_btn.png");
	pixBtn[1].load("./images/rock_btn.png");
	pixBtn[2].load("./images/paper_btn.png");
	btn1->setPixmap( pixBtn[0] );
	btn2->setPixmap( pixBtn[1] );
	btn3->setPixmap( pixBtn[2] );
	
	//-------------------
	pixResult[0].load("./images/lose.png");
	pixResult[1].load("./images/win.png");
	labelResult->hide();
	
    //-------------------
	imgCom[0].load("./images/scissors_rot.png");
	imgCom[1].load("./images/rock_rot.png");
	imgCom[2].load("./images/paper_rot.png");
	
	pixCom[0].convertFromImage( imgCom[0] );
	pixCom[1].convertFromImage( imgCom[1] );
	pixCom[2].convertFromImage( imgCom[2] );
	
    //-------------------
	imgUsr[0].load("./images/scissors.png");
	imgUsr[1].load("./images/rock.png");
	imgUsr[2].load("./images/paper.png");
	
	pixUsr[0].convertFromImage( imgCom[0].mirror(TRUE, TRUE) );
	pixUsr[1].convertFromImage( imgCom[1].mirror(TRUE, TRUE) );
	pixUsr[2].convertFromImage( imgCom[2].mirror(TRUE, TRUE) );
	


	//-------------------
	m_speed = 0;
	m_numUsr = 0;
	m_numCom = 0;
	
	m_result = DRAW;
	
	btn1->blockSignals(TRUE);	// signal-off
	btn2->blockSignals(TRUE);	// signal-off
	btn3->blockSignals(TRUE);	// signal-off

    connect( btn1,	SIGNAL( clicked() ),
			 SLOT( slotBtn1Clicked() )  );
	connect( btn2,	SIGNAL( clicked() ),
			 SLOT( slotBtn2Clicked() )  );
	connect( btn3,	SIGNAL( clicked() ),
			 SLOT( slotBtn3Clicked() )  );
	
    connect( this,	SIGNAL( signalSetNumUsr(int) ),
			 SLOT( slotGameResult(int) )  );
//	connect( this, SIGNAL( signalGameStart() ),
//			 SLOT( slotGameStart() )  );

	//slotGameStart();
}

void CWGame::timerEvent( QTimerEvent* )
{
	m_numCom = (m_numCom+1)%3;
	setScrCom();
}


void CWGame::showEvent( QShowEvent* )
{
	btn1->blockSignals(FALSE);	// signal-on
	btn2->blockSignals(FALSE);	// signal-on
	btn3->blockSignals(FALSE);	// signal-on
	
	money = 0;
	
	startTimer(500);
}


void CWGame::setScrCom()
{
	labelScrCom->setPixmap( pixCom[ m_numCom ] );
}

void CWGame::setScrUsr()
{
	labelScrUsr->setPixmap( pixUsr[ m_numUsr ] );
}

// 버튼 클릭시그널 -> 슬롯들
void CWGame::slotBtn1Clicked()
{
	emit signalSetNumUsr( SCISSORS );
}

void CWGame::slotBtn2Clicked()
{
	emit signalSetNumUsr( ROCK );
}

void CWGame::slotBtn3Clicked()
{
	emit signalSetNumUsr( PAPER );
}

void CWGame::gameInit(void)
{
	labelScrCom->setPixmap( pixMark );
	labelScrUsr->setPixmap( pixMark );
	
	m_numUsr = 0;
	m_numCom = 0;
	
	m_result = DRAW;
	
	btn1->blockSignals(TRUE);	// signal-off
	btn2->blockSignals(TRUE);	// signal-off
	btn3->blockSignals(TRUE);	// signal-off
	
	labelResult->hide();
}

/*
void CWGame::slotGameStart(void)
{
	btn1->blockSignals(FALSE);	// signal-on
	btn2->blockSignals(FALSE);	// signal-on
	btn3->blockSignals(FALSE);	// signal-on
	
	startTimer(1000);
}
*/

void CWGame::slotGameResult(int num)
{
	// 타이머 중지
	killTimers();
	
	// 시그날 중지
	btn1->blockSignals(TRUE);	// signal-off
	btn2->blockSignals(TRUE);	// signal-off
	btn3->blockSignals(TRUE);	// signal-off
	
	// 인수로 받은 값으로 사용자 값 설정
	m_numUsr = num;
	
	// 비교 및 결과값 저장
	m_result = checkNum( m_numCom, m_numUsr );
	
	if ( m_result == 0 )
	{
		m_numCom = (m_numCom+2)%3;
		m_result = 1;
	}
	
	// 화면 출력
	setScrCom();
	setScrUsr();

	// 결과 글 출력 및 money
	if ( m_result == WIN )
	{
		labelResult->setPixmap( pixResult[1] );
		money = 20;
	}
	else
	{
		labelResult->setPixmap( pixResult[0] );
		money = 10;
	}
	labelResult->show();

	QTimer::singleShot( 1000*2, this, SLOT( slotGameEnd() )  );
	// emit signalGameEnd();
}

void CWGame::slotGameEnd()
{
	gameInit();
	emit signalGameEnd();
}

int CWGame::checkNum(int numCom, int numUsr)
{
	int result = numUsr - numCom;
	if ( result == 2 || result == -2 )
	{
		result = result / (-2);
	}
	return result;
}

/*
void CWGame::slotCheckDraw(void)
{
	if ( m_result == DRAW )
	{
		emit signalGameStart();
	}
	else
	{
		emit signalGameEnd( m_result );
		gameInit();
	}
}

void CWGame::showResult(void)
{
	switch ( m_result )
	{
	case DRAW: // draw
		caseDraw();
		break;
		
	case LOSE: // lose
		caseLose();
		break;
		
	case WIN: //win
		caseWin();
		break;
		
	}
}

void CWGame::caseDraw(void)
{
	// QMessageBox::information(this, "caption", kor("비겼네요..다시!") );
	labelGuide->setText( kor("비겼네요..다시!") );
}

void CWGame::caseLose(void)
{
	// QMessageBox::information(this, "caption", kor("아깝습니다...") );
	labelGuide->setText( kor("아깝습니다...") );
}

void CWGame::caseWin(void)
{
	// QMessageBox::information(this, "caption", kor("이겼습니다! +_+") );
	labelGuide->setText( kor("이겼습니다! +_+") );
}

*/

