#ifndef _CPacket_
#define _CPacket_

#define DATA_SIZE 28

#define TAGID_SIZE 17
#define CARDID_SIZE 10
#define RECLAIMERID_SIZE 5
#define PRODUCTID_SIZE 6

//*****************************************************************************
// 패킷 정의
//*****************************************************************************
typedef struct packet_t packet_t;

struct packet_t
{
	int header;
	char data[ DATA_SIZE ];
};

//=============================================================================
// 사용자 확인 데이타
//=============================================================================
struct packetData_t_CTS_REQ_USER
{
	char tagID[ TAGID_SIZE ] ;
};
//----------------------------------------
struct packetData_t_STC_RES_USER_OK
{
	char cardID[ CARDID_SIZE ];
	int totalMoney;	
};
//----------------------------------------
struct packetData_t_STC_RES_USER_FAIL
{
	
};

//=============================================================================
// 총적립금 조회 데이타
//=============================================================================
struct packetData_t_CTS_REQ_MONEY
{
	char cardID[ CARDID_SIZE ];
};
//----------------------------------------
struct packetData_t_STC_RES_MONEY_OK
{
	int totalMoney;
};
//----------------------------------------
struct packetData_t_STC_RES_MONEY_FAIL
{
	
};

//=============================================================================
// 환급금액 조회 데이타
//=============================================================================
struct packetData_t_CTS_REQ_REFUND
{
	char productID[ PRODUCTID_SIZE ];
};
//----------------------------------------
struct packetData_t_STC_RES_REFUND_OK
{
	int productMoney;
};
//----------------------------------------
struct packetData_t_STC_RES_REFUND_FAIL
{
	
};

//=============================================================================
// 회수결과 전송 데이타
//=============================================================================
struct packetData_t_CTS_SND_RECOVERY
{
	char productID[ PRODUCTID_SIZE ];
	char cardID[ CARDID_SIZE ];
	char reclaimerID[ RECLAIMERID_SIZE ];
};
//----------------------------------------
struct packetData_t_STC_RES_RECOVERY_OK
{
};
//----------------------------------------
struct packetData_t_STC_RES_RECOVERY_FAIL
{
};

//=============================================================================
// 적립금 전송 데이타
//=============================================================================
struct packetData_t_CTS_SND_POINT
{
	char cardID[ CARDID_SIZE ];
	int productMoney;
	int gameMoney;
};
//----------------------------------------
struct packetData_t_STC_RES_POINT_OK
{
};
//----------------------------------------
struct packetData_t_STC_RES_POINT_FAIL
{
};

#endif // _CPacket_
