/*
 * =====================================================================================
 *
 *       Filename:  uart.h
 *
 *    Description:  RS-232
 *
 *        Version:  1.0
 *        Created:  2008년 09월 03일 20시 26분 13초
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Sangwoo Kim, nanum99@korea.com 
 *        Company:  my-company
 *
 * =====================================================================================
 */
#ifndef __UART_H__
#define __UART_H__

#include <iostream>
#include <termios.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

class CUart
{
private:
	char m_deviceName[64];
	int m_fd;
public:

	CUart(char * deviceName = "/dev/ttyS0");
	~CUart();
	int uWrite(char * buffer, unsigned int size);
	int uRead(char * buffer, unsigned int size);
	void uOpen(unsigned int option = B38400 | CS8 | CLOCAL | CREAD);
	void uClose();
	void setDeviceName(char * str);
};

#endif
