/*
 ******************************************************************************
 *
 * file name : motor.c
 * description : ATMEGA128  α׷
 *   : CodeVisionAVR 1.24.8d professional
 * 
 ******************************************************************************
 */
 
#include <mega128.h> 
#include <delay.h> 

#define MILLISECOND 238 // TCNTx  ʱⰪ
\
#define MOTOR_START 0x01
#define MOTOR_STOP 0x00   

/*
#define KEY_A_MOTOR 'a'
#define KEY_B_MOTOR 'b'
#define KEY_C_MOTOR 'c'
#define KEY_D_MOTOR 'd'
*/

#define IMGPROC_READY 'r' //   ̵
#define IMGPROC_FAIL 'f' //  ڷ ̵
#define IMGPROC_RETRY 't' // B_MOTOR 10 ̵
#define RES_CAN 'c'        // ĵ
#define RES_PT 'p'         // PT
#define RES_BOTTLE 'b'     // 

#define MSG_FAIL 0
#define MSG_OK 1
#define MSG_COMMAND 2

#define A_MOTOR 0xFE
#define B_MOTOR 0xFD
#define C_MOTOR 0xFB
#define D_MOTOR 0xEF

void moveObject(void);  //   ̵
void resetObject(void); //  ڷ ̵
void bmotor(void);      // B_MOTOR 10 ̵
void motor(unsigned int motorSelect, int angle);        // ( , )
void motorStop(void);	        //  
void connSerial(void);	        // ø Ʈ 
void recovery(void);            // ȸ
void printStr(char * str); 
void putData(char data);
void recoveryCan(void);
void recoveryPt(void);
void recoveryBottle(void);
void motorReset(void);          //ü  Reset

char isMotorStatus = MOTOR_STOP;	//   =  

unsigned int timer0Cnt;		        // Ÿ̸0 ͷƮ ī͸  

/**********************************************
		ش   ޽(ms)
60(0.60ms) - 0 , 75(0.75ms) - 45,
150(1.50ms) - 90, 195(1.95ms) - 135,
240(2.40ms) - 180 
************************************************/

/*
char * welMsg[] = {      "FAIL\r\n", 
                        "OK\r\n", 
                        "\r\nCommand - Select_MOTOR [a - A_MOTOR, b - B_MOTOR, c - C_MOTOR, d - D_MOTOR]:\r\n " 
                };
*/
char * welMsg[] = {      "FAIL\r\n", 
                        "OK\r\n", 
                        "\r\nCommand - Product Recovery [ c - CAN, p - PT, b - BOTTLE ]:\r\n " 
                };

void bmotor(void)
{
        static int angle = 0;
        angle = (angle + 60) % 180;
        if(1)
        {
                motor(B_MOTOR, angle );
        }
        else
        {
                motor(B_MOTOR, angle-=60);
        }
        
        return ;
}

void moveObject(void)
{
        //motor(A_MOTOR, 180); 
        //delay_ms(1000);
        motor(A_MOTOR, 55);
        return;
}
 
void resetObject(void)
{
        //motor(A_MOTOR, 0);
        //delay_ms(1000); 
        motor(A_MOTOR, 0);                                                 
}

void recovery(void)
{
        //delay_ms(1000);
        motor(A_MOTOR, 170);
        delay_ms(1000);
}

void recoveryCan(void)
{			  
        motor(C_MOTOR, 180);
        delay_ms(1000);
        motor(D_MOTOR, 50);        
        
        recovery();      
 	printStr(welMsg[MSG_OK]); 
        return ;
}

void recoveryPt(void)
{
        motor(D_MOTOR, 0);
        delay_ms(1000);
        motor(C_MOTOR, 180);
        
        recovery();
        printStr(welMsg[MSG_OK]);        
        return ;
}

void recoveryBottle(void)
{
        motor(D_MOTOR, 0);
        delay_ms(1000);
        motor(C_MOTOR, 130);
        
        recovery();
	printStr(welMsg[MSG_OK]);
        return ;
}

void motorReset(void)
{
        /*
        motor(A_MOTOR, 0);
        delay_ms(1000); 
        motor(A_MOTOR, 180);                                                 
 
        delay_ms(1000); 
        motor(D_MOTOR, 0);
        delay_ms(1000);
        motor(C_MOTOR, 180);
        return ;
        */
        resetObject();
        
        delay_ms(1000); 
        motor(D_MOTOR, 0);
        delay_ms(1000);
        motor(C_MOTOR, 180);        
        return ;
}

void printStr( char * str)
{
        while(*str) putData(*str++);
}
void putData(char data)
{
        while(!(UCSR0A & 0x20));
        UDR0 = data;	                // ۽  Ͱ 1̶ ۽ ۿ data .  

}

void connSerial(void)
{
        UCSR0A = 0x00;			// USART    A

        UCSR0B = 0b10011000;	// USART    B
		// Ʈ 4 - USARTn Receiver Enable, Ʈ 3 - USARTn Transmitter Enable
								
        UBRR0L = 103;			// USART Baud Rate(BPS)  ( Baud Rate = 9600 )
        UBRR0H = 0;				//
        
        SREG = 0x80;			// ü ͷƮ Enable
}

int main(void)
{
	connSerial();	// ø Ʈ 
        
        printStr(welMsg[MSG_COMMAND]);
	
	while(1);

	return 0;
}

// Ÿ̸0 ÷ο ͷƮ( TCNT0 ÷ο찡 ߻ϸ ͷƮ ߻)
interrupt [TIM0_OVF] void timer0Int(void)
{
	timer0Cnt++;
	TCNT0 = MILLISECOND;	// Ÿ̸/ī 
}  

// USART0εͰ ŵǸ ߻ϴ ͷƮ
interrupt [USART0_RXC] void usart0RecvInt(void)
{
        char recvData; // ŵ Data  

	recvData = UDR0;	   // ŵ Data 

        putData(recvData);
        putData('\r');
        putData('\n');
        /*
        switch(recvData)
        {
                 case KEY_A_MOTOR:
                        motor(A_MOTOR, 180); 
                        delay_ms(1000);
                        motor(A_MOTOR, 135);
			
                        motor(B_MOTOR, 180); 
                        delay_ms(1000);
                        motor(B_MOTOR, 0);
			
                        motor(D_MOTOR, 0);  
                        motor(C_MOTOR, 130);
                        
                        
                        delay_ms(1000); 
                        motor(A_MOTOR, 0);
                        delay_ms(1000); 
                        motor(A_MOTOR, 180);                                                 
			printStr(welMsg[MSG_OK]); 
			break;			
        }
        motorStop();
        */
        switch(recvData)
        {
                case IMGPROC_READY:
                        moveObject();
                        break;
                case IMGPROC_FAIL:
                        resetObject();
                        break;
                case IMGPROC_RETRY:
                        bmotor();
                        break;
                case RES_CAN:
                        recoveryCan();        
                        delay_ms(1000);
                        motorReset();
			break;
                case RES_PT:
                        recoveryPt();
                        delay_ms(1000);
                        motorReset();
                        break;
                case RES_BOTTLE:
                        recoveryBottle();
                        delay_ms(1000);
                        motorReset();
			break;
        }
        /*
        delay_ms(1000);
        motorReset();
        */
        motorStop();    

}    

void motorStop(void)
{
        TIMSK = 0x00;					// Ÿ̸ ÷ο ͷƮ Disable
        isMotorStatus =  MOTOR_STOP;	//   =  
        #asm("cli");

}

void motor(unsigned int motorSelect, int angle)
{
        int change = 0;		//  ȭ ֱ = 0

        timer0Cnt = 1;	// Ÿ̸0 ͷƮ ī͸ 1 ʱȭ
	
	TIMSK = 0x01;	// Ÿ̸ ÷ο ͷƮ Enable
	TCCR0 = 0x02;	// Ÿ̸/ī  (Ϲݸ, =CK/8)
	TCNT0 = MILLISECOND;
	
	angle = angle + 60;
	
	SREG = 0x80;      // ü ͷƮ Enable
	
	PORTA = 0xFF;		//PORTA   Logic Low(0) (Ǯ )
	
	isMotorStatus = MOTOR_START;	//   =  

     while(isMotorStatus && change <= 50)   // 20ms X 50 = 1sec  ȭ ֱ üũ
	 {
		
		if ( timer0Cnt >= 2000 )	// 20ms ֱ üũ
		{
			timer0Cnt = 0;
			PORTA = 0xFF;
		   	change++;
		}
		
		if ( timer0Cnt >= angle)//motorAngle[angle])
		{
		      PORTA = motorSelect;	// Motor (Ǯ )
		        
		}   
	 }   
}
